// Pingus - A free Lemmings clone
// Copyright (C) 1999 Ingo Ruhnke <grumbel@gmx.de>

// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.

// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

#include <iostream>
#include <cassert>
#include <ClanLib/clanlib.h>
#include <ClanLib/clanlayer2.h>

#include "walker.hh"

Walker::Walker()
{
  surface = CL_Res_Surface::load("Pingus/walker", *resource);
  counter.set_size(8);
  is_multi_direct = true;
}

void
Walker::let_move()
{
  //  cout << "Moving Walker" << endl;
  //cout << data->x_pos << " " << data->y_pos << endl;
  
  //  ++data->x_pos;
  //  ++data->y_pos;
 
  if (rel_getpixel(0, -1) == 0) {
    ++data->y_pos;
    if (rel_getpixel(0, -1) == 0) 
      ++data->y_pos;
  } else {

    if (rel_getpixel(1, 0) == 0) { // if infront is free
      data->x_pos += data->direction;    
    } else { // if infront is a pixel 
      // Pingu is walking mounten up/down
      if (rel_getpixel(1,1)== 0) {
	data->x_pos += data->direction;
	--data->y_pos;
      } else if (rel_getpixel(1,2)== 0) {
	data->x_pos += data->direction;
	data->y_pos -= 2;
      } else {
	change(data->direction);
      }
    }
  }
}

/* EOF */
