// Copyright (C) 1999 Ingo Ruhnke <grumbel@gmx.de>, see README.TXT for details

#include <cassert>

#include "exit.hh"
#include "actions/pingu_actions.hh"

CL_Surface* Exit::surface;

Exit::Exit(int x, int y)
{
  x_pos = x;
  y_pos = y;
}

Exit::Exit(exit_data data)
{
  x_pos = data.x_pos;
  y_pos = data.y_pos;
}

void 
Exit::catch_pingu(Pingu* pingu)
{
  const int range = 3;

  if (pingu->get_x() > x_pos-1 && pingu->get_x() < x_pos+1 &&
      pingu->get_y() > y_pos-range && pingu->get_y() < y_pos+range) 
    {
      pingu->set_action(new Bomber);
    }
}

/*void
Exit::draw()
{
  assert(surface);
  surface->put_screen(x_pos-32, y_pos-64);
  }*/

void
Exit::draw_offset(int x, int y)
{
  assert(surface);
  surface->put_screen(x_pos + x - 32, y_pos + y - 64);
}

void 
Exit::load_data(CL_ResourceManager* resource)
{
  cout << surface << endl;
  surface = CL_Res_Surface::load("Game/exit", *resource);
  cout << surface << " Bla" << endl;
  assert(surface);
  cout << "Exit loaded" << endl;
}

/* EOF */
